<?php
/*
Plugin Name: IMGspider
Plugin URI: http://wordpress.org/plugins/imgspider/
Description: IMGspider（图片蜘蛛）是一款用于WordPress文章站外图片抓取的WordPress插件，支持JPG, JPEG, PNG, GIF等常见图片爬取下载，实现一键抓取文章内容所有引用图片到本地服务器；并支持使用默认代理或者自主配置代理服务器加速爬取下载。
Author: wbolt team
Version: 1.0.1
Author URI: http://www.wbolt.com/
*/
define('IMGSPY_PATH',dirname(__FILE__));
define('IMGSPY_BASE_FILE',__FILE__);
define('IMGSPY_VERSION','1.0.1');



class IMGSPY_Admin
{
    protected static $mime_to_ext = array (
        'image/jpeg' => 'jpg',
        'image/png' => 'png',
        'image/gif' => 'gif',
        'image/bmp' => 'bmp',
        'image/tiff' => 'tif'
    );

    protected static $ext_to_mime = array (
        'jpg' => 'image/jpeg',
        'jpeg' => 'image/jpeg',
        'png' => 'image/png',
        'gif' => 'image/gif',
        'bmp' => 'image/bmp',
        'tif' => 'image/tiff',
    );

    private static $use_proxy_serv = false;

    public function __construct()
    {

        if(is_admin()){

            add_action('media_buttons', array($this, 'add_media_button'), 20);

            add_action('admin_head-post.php',array(__CLASS__,'admin_head'));
            add_action('admin_head-post-new.php',array(__CLASS__,'admin_head'));

            add_action('wp_ajax_wb_scrapy_image',array(__CLASS__,'wp_ajax_wb_scrapy_image'));

            add_filter( 'admin_init' , array(__CLASS__,'admin_init') );

            add_filter('plugin_row_meta', array(__CLASS__, 'plugin_row_meta'), 10, 2);


        }



    }

    public static function plugin_row_meta($links,$file){

        $base = plugin_basename(IMGSPY_BASE_FILE);
        if($file == $base) {
            $links[] = '<a href="https://www.wbolt.com/plugins/imgspider/">插件主页</a>';
            $links[] = '<a href="https://www.wbolt.com/imgspider-plugin-documentation.html">FAQ</a>';
            $links[] = '<a href="https://wordpress.org/support/plugin/imgspider/">反馈</a>';
        }
        return $links;
    }
    public static function admin_init(){
        register_setting( 'general', 'wb_IMGSPY_proxy' );
        add_settings_field('wb_IMGSPY_proxy', '<label for="wb_IMGSPY_proxy">ImgSpider代理</label>' , array(__CLASS__,'render_setting_field'), 'general' );
    }

    public static function render_setting_field(){
        $value = get_option( 'wb_IMGSPY_proxy', '' );

        echo '<input name="wb_IMGSPY_proxy" type="text" id="wb_IMGSPY_proxy" value="'.$value.'" class="regular-text ltr">';
        echo '<p class="description" id="wb_IMGSPY_proxy-description">格式为ip:端口，如:206.189.64.103:3128</p>';
    }

    public static function wp_ajax_wb_scrapy_image(){

        //ini_set('display_errors',true);
        //print_r($_POST);
        set_time_limit ( 600 );
        $img = $_POST['image'];
        $proxy_cnf = trim($_POST['proxy']);
        if(!$proxy_cnf){
            $proxy_cnf = get_option('wb_IMGSPY_proxy',false);
        }
        $proxy_serv = $_POST['proxy_serv'];


        if($proxy_cnf){
            if(!defined('WP_PROXY_HOST'))define('WP_PROXY_HOST',trim($proxy_cnf));
            /*$proxy = explode(':',$proxy_cnf);
            if(!defined('WP_PROXY_HOST') && $proxy[0])define('WP_PROXY_HOST',trim($proxy[0]));
            if(!defined('WP_PROXY_PORT') && $proxy[1])define('WP_PROXY_PORT',trim($proxy[1]));*/
        }else if($proxy_serv){

            self::$use_proxy_serv = true;
        }
        //print_r([WP_PROXY_HOST,WP_PROXY_PORT]);exit();
        //print_r($images);exit();

        $ret_list = array();
        if($img){

            $img =  rawurldecode($img);
            $img = str_replace('&amp;','&',$img);
            //exit();
            //$img = urldecode(urldecode($img));
            //echo $img;
            $ret = self::upload($img,0,false);
            //print_r($ret);exit();
            if($ret){
                $img_html = '<img class="alignnone size-full';
                if($ret['id']){
                    $img_html .= ' wp-image-'.$ret['id'];
                }
                $img_html .= '" src="'.$ret['url'].'"';
                if($ret['width']){
                    $img_html .= ' width="'.$ret['width'].'"';
                }
                if($ret['width']){
                    $img_html .= ' height="'.$ret['height'].'"';
                }
                $img_html .= ' alt="'.$ret['title'].'" />';

                $ret_list[] = $img_html;
            }
        }

        header('content-type:text:/json;charset=utf-8');
        echo json_encode($ret_list);
        exit();

    }


    public static function admin_head(){

        //echo __CLASS__;

        wp_enqueue_script('wbsm-main-js',plugin_dir_url(IMGSPY_BASE_FILE).'main.js',array('jquery'));
        wp_enqueue_script('wbsm-layer-js',plugin_dir_url(IMGSPY_BASE_FILE).'layer/layer.js',array('wbsm-main-js'));
        wp_enqueue_style('wbp-admin-style-imgspy',plugin_dir_url(IMGSPY_BASE_FILE).'assets/wbp_admin_imgspy.css', array(), IMGSPY_VERSION);
        wp_enqueue_script('wbp-admin-js-imgspy',plugin_dir_url(IMGSPY_BASE_FILE).'assets/wbp_admin_imgspy.js', array(), IMGSPY_VERSION, true);
    }



    function add_media_button(){


        $html = '<button id="wb-wbsm-btn" type="button" class="button wb-wbsm-btn"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16"><g fill="#999" fill-rule="evenodd"><path d="M6 16h4v-2H6zM6 2h4V0H6zM14 10h2V6h-2zM0 10h2V6H0zM12 8H9V4H7v4H4l4 4zM2 2h2V0H1C.4 0 0 .4 0 1v3h2V2zM15 0h-3v2h2v2h2V1c0-.6-.4-1-1-1M14 14h-2v2h3c.6 0 1-.4 1-1v-3h-2v2zM2 12H0v3c0 .6.4 1 1 1h3v-2H2v-2z"/></g></svg><span>保存站外图片</span></button>';
        echo $html;
    }



    public static function down($url,$args = array()){
        $defaults = array(
            'timeout' => 30,
            'redirection' => 5,
            'user-agent' => 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36',
            'sslverify' => false,
        );
        $http_options = wp_parse_args( $args, $defaults );

        set_time_limit ( 300 );


        if(self::$use_proxy_serv){
            $http = wp_remote_get ( 'https://proxy.wbolt.com/wp-admin/admin-ajax.php?action=down_img&url='.urlencode($url), $http_options );
        }else{

            $http = wp_remote_get ( $url, $http_options );
        }


        if (is_wp_error ( $http )) {

            //echo $http->get_error_message();
            return false;
        }
        if (200 === $http ['response'] ['code']) {
            $file_content = $http ['body'];
            if(isset($http_options['stream']) && $http_options['stream']){
                return $http;
            }
            return $file_content;
        } else {
            return false;
        }
    }
    public static function upload_image_name($image_url){

        $image_path = parse_url($image_url, PHP_URL_PATH);
        $filename =  basename($image_path);
        if(!preg_match('#\.([a-z0-9]+)$#',$filename)){

            if(preg_match('#wx_fmt=([a-z]+)#',$image_url,$m)){
                $filename .= '.'.$m[1];
            }else{

                $filename .= '.jpg';
            }
        }

        return str_replace('*','',$filename);
    }
    public static function upload($image_url,$post_id,$post_date){




        $filename = self::upload_image_name($image_url);


        $arg = array();
        if($_SERVER && isset($_SERVER['HTTP_USER_AGENT'])){
            $arg['user-agent'] = $_SERVER['HTTP_USER_AGENT'];
        }

        $image_data = self::down($image_url,$arg);

        if(!$image_data){
            return $image_data;
        }

        ini_set('memory_limit', '50M');

        do{

            $time = false;
            if($post_date) {
                $time = date('Y/m',strtotime($post_date));
            }
            $uploads = wp_upload_dir ( $time );

            $filename = urldecode($filename);
            $filename = str_replace(array('%20',' '), '_', $filename);
            //图片文件名称
            $unique_filename_callback = null;
            $filename = wp_unique_filename ( $uploads ['path'], $filename, $unique_filename_callback );

            $new_file = $uploads ['path'] . '/' . $filename;

            //下载图片
            if (!file_put_contents($new_file,$image_data)){
                break;
            }


            // Compute the URL
            $url = $uploads ['url'] . '/'.$filename;


            $name_parts = pathinfo ( $filename );


            $name = $name_parts['filename'];

            $title = $name;
            $content = '';


            $ret = array(
                'title'=>$title,
                'url'=>$url,
            );


            $mine_type = wp_get_image_mime($new_file);

            if(!$mine_type && isset(self::$ext_to_mime[$name_parts['extension']])){
                $mine_type = self::$ext_to_mime[$name_parts['extension']];
            }

            // Construct the attachment array
            $attachment = array (
                'post_mime_type' => $mine_type,
                'guid' => $url,
                'post_parent' => $post_id,
                'post_title' => $title,
                'post_content' => $content
            );


            $id = wp_insert_attachment ( $attachment, $new_file, $post_id );

            if (is_wp_error ( $id )) {
                return $ret;
            }

            $ret['id'] = $id;

            $metadata = wp_generate_attachment_metadata( $id, $new_file );
            if(!$metadata){
                return $ret;
            }

            if (is_wp_error ( $metadata )) {
               return $ret;
            }else if(!isset ( $metadata ['file'] )) {
                return $ret;
            }else{
                wp_update_attachment_metadata ( $id, $metadata );

                $ret['width'] = $metadata['width'];
                $ret['height'] = $metadata['height'];
            }
            return $ret;

        }while(false);

        return false;

    }
}


new IMGSPY_Admin();