(function($){
    var getContent = function () {

        var mce = tinyMCE?tinyMCE.activeEditor:false;

        if(mce && !mce.hidden){
            return mce.getContent({format : 'raw'});
        }else{
            return jQuery('#'+wpActiveEditor).val();
        }

        return false;
    };

    var setContent = function(content){
        var mce = tinyMCE?tinyMCE.activeEditor:false;
        if(mce && !mce.hidden){
            mce.setContent(content,{format : 'raw'});
        }else{
            jQuery('#'+wpActiveEditor).val(content);
        }
    };

    var continue_run = 1;
    var next_img_idx = 0;
    var max_img_idx = 0;
    var scrapy_cnf = {
        wb_switch:0,
        proxy_type:0,
        proxy:'',
        all_done : true
    }




    var req_remote = function(content,img_list,img_html){

        var ipt = $('#scrapy_img_'+next_img_idx);
        ipt.next().attr('class','wb-icon def');

        //console.log(scrapy_cnf);
       var post_param = {action:'wb_scrapy_image','image':img_list[next_img_idx],'proxy':'','proxy_serv':''};
       if(scrapy_cnf.wb_switch){
           var proxy_type = parseInt(scrapy_cnf.proxy_type)
           if(proxy_type){
               post_param.proxy = scrapy_cnf.proxy;
           }else{
               post_param.proxy = '';
               post_param.proxy_serv = '1';
           }
       }

        $.post(ajaxurl,post_param,function(ret){
            //console.log(ret);
            //layer.close(load_index);
            //var all_done = true;

            if(ret && ret.length){
                var replace = ret[0],search = img_html[next_img_idx];
                content = content.replace(search,replace);
                setContent(content);
                ipt.next().attr('class','wb-icon ok');
                ipt.val($(replace).attr('src'));

            }else{
                ipt.next().attr('class','wb-icon error');
                scrapy_cnf.all_done = false;
            }

            next_img_idx ++;
            if(next_img_idx > max_img_idx){
                var _msg = scrapy_cnf.all_done ? '<i class="wb-icon done"></i><span>恭喜你，采集完成！</span>' : '<span>采集完成...</span>';
                $('#J_wbDialogMainPanel .wbd-ft').html('<div class="msg">' + _msg + '</div>');
                return;
            }

            if(continue_run){
                req_remote(content,img_list,img_html)
            }
        },'json');
    };



    $("#wb-wbsm-btn").on('click',function(){

        var content = getContent();
        var patten = new RegExp('<img.+?src=([^\\s]+).+?>','g');
        var re = /https?:\/\/[^\/]+/g;
        var home_url = window.location.href.match(re)[0];
        var img_list = [];
        var img_html = [];
        while (result = patten.exec(content)) {
            img_url =  result[1].replace(/("|')/g,'');
            if(img_url.indexOf(home_url)>-1)continue;
            if(!/^https?:\/\//.test(img_url))continue;
            img_list.push(img_url);
            img_html.push(result[0]);
        }

        if(img_list.length<1){
            WBIMGspider.toast('没有找到需要下载的远程图片');
            return;
        }


        var html = '<div class="scrapy-list-inner">' +
            '<label class="wb-switch-item">' +
            '<span>加速开关</span>' +
            '<input class="wb-switch" id="J_proxySwitch" type="checkbox" value="0" data-target="#J_proxySetting">' +
            '</label>';

        html += '<div class="proxy-setting-box default-hidden-box" id="J_proxySetting">' +
                '<div class="selector-bar mb">' +
                    '<label><input class="wbs-radio" type="radio" name="proxySettingItem" value="0"> 默认代理</label>' +
                    '<label><input class="wbs-radio" type="radio" name="proxySettingItem" value="1"> 自定义代理</label>' +
                '</div>' +
                '<input class="wbs-input" style="display:none;" type="text" id="scrapy_proxy" value="" placeholder="请输入您的代理服务器，如:206.189.64.103:3128">' +
            '</div>';

        html += '<h3>图片下载列表</h3>' +
            '<ul class="item-list">';

        for(var i=0;i<img_list.length;i++){
            html += '<li><input class="wbs-input" type="input" id="scrapy_img_'+i+'" value="'+img_list[i]+'"><span class="wb-icon def"></span></li>';
        }
        html += '</ul></div>';
        html += '<div class="wbd-ft"><input type="button" class="wb-btn wb-btn-primary button" value="开始采集" id="start_scrapy"> </div>';
        html += '</div>';

        WBIMGspider.dialogMainPanel(html,{
            title: '保存站外图片',
            init: function() {
                var $proxySettingItem = $('input[name="proxySettingItem"]');
                var _selected = WBIMGspider.localStorage.get('wb_scrapy_proxy_item') || 0;
                var _val = WBIMGspider.localStorage.get('wb_scrapy_proxy') || '';
                var wb_proxy_switch = parseInt(WBIMGspider.localStorage.get('wb_proxy_switch'));

                scrapy_cnf.wb_switch = wb_proxy_switch;
                scrapy_cnf.proxy_type = _selected;
                scrapy_cnf.proxy = _val;
                scrapy_cnf.all_done = true;

                $proxySettingItem.eq(_selected).attr('checked','checked');

                WBIMGspider.switchAction($);

                $('#J_proxySwitch').on('change',function () {
                    var me = $(this);
                    if (me.prop("checked")) {
                        scrapy_cnf.wb_switch = 1;
                        WBIMGspider.localStorage.set('wb_proxy_switch',1);
                    }else{
                        scrapy_cnf.wb_switch = 0;
                        WBIMGspider.localStorage.set('wb_proxy_switch',0);
                    }
                });

                if(wb_proxy_switch){
                    $('#J_proxySwitch').attr('checked','checked');
                    $('#J_proxySetting').addClass('active');
                }else{
                    $('#J_proxySwitch').removeAttr('checked');
                    $('#J_proxySetting').removeClass('active');
                }

                if(_selected == 0){
                    $('#scrapy_proxy').hide();
                }else{
                    $('#scrapy_proxy').val(_val).show();
                }

                $proxySettingItem.on('change', function () {
                    var val = $(this).val();
                    scrapy_cnf.proxy_type = val;
                    WBIMGspider.localStorage.set('wb_scrapy_proxy_item', val);
                    if(val == 0){
                        $('#scrapy_proxy').hide();
                    }else{
                        $('#scrapy_proxy').show().select();
                    }
                });
            },destroy:function(){

                continue_run = 0;
            }

        });


        $('#start_scrapy').on('click',function () {


            max_img_idx = img_list.length-1;
            next_img_idx = 0;

            if(scrapy_cnf.wb_switch && scrapy_cnf.proxy_type){
                scrapy_cnf.proxy = $('#scrapy_proxy').val();
                WBIMGspider.localStorage.set('wb_scrapy_proxy', $('#scrapy_proxy').val());
            }

            $('#J_wbDialogMainPanel .wbd-ft').html('<div class="msg">采集中...</div>');

            req_remote(content, img_list, img_html);

        });



    });
})(jQuery);